﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BindToSelectedChieldRow
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            ViewModel vm = new ViewModel();

            InitializeComponent();

            this.DataContext = vm;
        }

    }



    public class ViewModel : PropertyChangedNotifier
    {
        public ViewModel()
        {
            GridData = TreeData.GenerateTreeData();
            
        }


        private ObservableCollection<TreeData> _gridData;
        public ObservableCollection<TreeData> GridData
        {
            get { return _gridData; }
            set
            {
                _gridData = value;
                OnPropertyChagned("GridData");
            }
        }

        private object[] _mySelectedItems;
        public object[] MySelectedItems 
        {
            get
            {
                    return _mySelectedItems;
            }
            set
            {
                  _mySelectedItems = value;
                OnPropertyChagned("MySelectedItems");
            }
        }
       
    }

    
    public class TreeData : PropertyChangedNotifier
    {
        private int id;

        public int ID
        {
            get { return id; }
            set { id = value; OnPropertyChagned("ID"); }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChagned("Name"); }
        }

        private ObservableCollection<TreeData> children;

        public ObservableCollection<TreeData> Children
        {
            get { return children; }
            set { children = value; OnPropertyChagned("Children"); }
        }

        public static ObservableCollection<TreeData> GenerateTreeData()
        {
            ObservableCollection<TreeData> data = new ObservableCollection<TreeData>();

            for (int i = 0; i < 10; i++)
            {
                TreeData n = new TreeData
                {
                    ID = i,
                    Name = "Item " + i,
                    Children = new ObservableCollection<TreeData>()
                };

                for (int j = 0; j < 5; j++)
                {
                    TreeData n1 = new TreeData
                    {
                        ID = i + j,
                        Name = "Item " + i + " " + j,
                        Children = new ObservableCollection<TreeData>()
                    };

                    n.Children.Add(n1);
                }

                data.Add(n);
            }

            return data;
        }

    }

    public class PropertyChangedNotifier : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

}
